require "bit" 
require "jit" 
require "copy"

jit.on() -- jit.off()

--xMouse, yMouse = love.mouse.getPosition()
--lenta = love.graphics.newImage("board.png")
--down = love.mouse.isDown( button ) button = 1,2,etc

-- globals
tomove = BLACK
selected = nil
frames = 0
found = false
piece = nil
depth = 7 -- you can change in between 1 - 15 or more,but search
-- will go for a very,very long time
--



function love.load()
--

love.graphics.reset()

love.window.setMode(528,528)
love.window.setMode(528,528)
img = love.graphics.newImage("normal.png") -- background
garsas = love.audio.newSource('move.wav','static') 
love.keyboard.setTextInput( true )
love.keyboard.setKeyRepeat( true )

end


math.randomseed(os.time())-- for better randomness


local cellSize = 528 / 8
local gridLines = {} 
local wWidth,wHeight = love.graphics.getDimensions()


for x = 0, 528, cellSize do
local line = {x, 0,x,528}
 table.insert(gridLines, line)
end

for y = 0, 528, cellSize do
local line = {0, y,528,y} 
 table.insert(gridLines, line)
end

FREE = 16; 

WHITE = 1; 
BLACK = 2; 
MAN = 4; 
KING = 8; 

UNUSED = 0; 

board = {}

board[1] = UNUSED 
board[2] = UNUSED 
board[3] = UNUSED 
board[4] = UNUSED 
board[5] = UNUSED 
board[6] = UNUSED 
board[7] = UNUSED 
board[8] = UNUSED 
board[9] = UNUSED 
board[10] = bit.bor(WHITE,MAN)
board[11] = bit.bor(WHITE,MAN)
board[12] = bit.bor(WHITE,MAN)
board[13] = bit.bor(WHITE,MAN)

board[14] = bit.bor(WHITE,MAN)
board[15] = bit.bor(WHITE,MAN)
board[16] = bit.bor(WHITE,MAN)
board[17] = bit.bor(WHITE,MAN)
board[18] = UNUSED 
board[19] = bit.bor(WHITE,MAN)
board[20] = bit.bor(WHITE,MAN)
board[21] = bit.bor(WHITE,MAN)
board[22] = bit.bor(WHITE,MAN)
board[23] = FREE
board[24] = FREE
board[25] = FREE
board[26] = FREE 
board[27] = UNUSED 
board[28] = FREE 
board[29] = FREE
board[30] = FREE
board[31] = FREE
board[32] = bit.bor(BLACK,MAN)
board[33] = bit.bor(BLACK,MAN)
board[34] = bit.bor(BLACK,MAN)
board[35] = bit.bor(BLACK,MAN)
board[36] = UNUSED 
board[37] = bit.bor(BLACK,MAN)
board[38] = bit.bor(BLACK,MAN)
board[39] = bit.bor(BLACK,MAN)
board[40] = bit.bor(BLACK,MAN)

board[41] = bit.bor(BLACK,MAN)
board[42] = bit.bor(BLACK,MAN)
board[43] = bit.bor(BLACK,MAN)
board[44] = bit.bor(BLACK,MAN)

board[45] = UNUSED 
board[46] = UNUSED 
board[47] = UNUSED 
board[48] = UNUSED 
board[49] = UNUSED 
board[50] = UNUSED 
board[51] = UNUSED 
board[52] = UNUSED 
board[53] = UNUSED 
board[54] = UNUSED 


--[[
board[1] = UNUSED 
board[2] = UNUSED 
board[3] = UNUSED 
board[4] = UNUSED 
board[5] = UNUSED 
board[6] = UNUSED 
board[7] = UNUSED 
board[8] = UNUSED 
board[9] = UNUSED 
board[10] = FREE --bit.bor(WHITE,MAN)
board[11] = FREE -- bit.bor(WHITE,MAN)
board[12] = FREE --bit.bor(WHITE,MAN)
board[13] = bit.bor(WHITE,KING)  --bit.bor(WHITE,MAN)

board[14] = FREE --bit.bor(WHITE,MAN)
board[15] = bit.bor(BLACK,MAN) --bit.bor(WHITE,MAN)
board[16] = bit.bor(BLACK,MAN) --bit.bor(WHITE,MAN)
board[17] = bit.bor(BLACK,MAN) --bit.bor(WHITE,MAN)
board[18] = UNUSED 
board[19] = FREE -- bit.bor(WHITE,MAN)
board[20] = FREE -- bit.bor(WHITE,MAN)
board[21] = FREE -- bit.bor(WHITE,MAN)
board[22] = FREE -- bit.bor(WHITE,MAN)
board[23] = FREE
board[24] = bit.bor(BLACK,MAN) --FREE
board[25] = bit.bor(BLACK,MAN) --FREE
board[26] = bit.bor(BLACK,MAN) --FREE 
board[27] = UNUSED 
board[28] = FREE 
board[29] = FREE
board[30] = FREE
board[31] = FREE
board[32] = FREE --bit.bor(BLACK,MAN)
board[33] = bit.bor(BLACK,MAN)
board[34] = bit.bor(BLACK,MAN)
board[35] = bit.bor(BLACK,MAN)
board[36] = UNUSED 
board[37] = FREE --bit.bor(BLACK,MAN)
board[38] = FREE --bit.bor(BLACK,MAN)
board[39] = FREE --bit.bor(BLACK,MAN)
board[40] = FREE --bit.bor(BLACK,MAN)

board[41] = FREE --bit.bor(BLACK,MAN)
board[42] = FREE --bit.bor(BLACK,MAN)
board[43] = FREE --bit.bor(BLACK,MAN)
board[44] = FREE --bit.bor(BLACK,MAN)

board[45] = UNUSED 
board[46] = UNUSED 
board[47] = UNUSED 
board[48] = UNUSED 
board[49] = UNUSED 
board[50] = UNUSED 
board[51] = UNUSED 
board[52] = UNUSED 
board[53] = UNUSED 
board[54] = UNUSED 
--]]


-- bad name aa for this table.

aa = { {0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},
{0,0},{0,0},
{98,32},{ 230,32},{362,32},{494,32},
{32,98},{164,98},{296,98},{428,98}
,{0,0},
{98,164},{230,164},{362,164},{494,164},

{32,230},{164,230},{296,230},{428,230},
{0,0},
{98,296},{230,296},{362,296},{494,296},
{32,362},{164,362},{296,362},{428,362},
{0,0},
{98,428},{230,428},{362,428},{494,428},
{32,494},{164,494},{296,494},{428,494},
{0,0},{0,0},{0,0},{0,0},{0,0},
{0,0},{0,0},{0,0},{0,0},{0,0} }

-- bb also bad name it says nothing
bb = {}

for i = 0,7 do
  bb[i] = {}
  for j = 0,7 do
   bb[i][j] = 0
  end
end


bb[1][0] = 10
bb[3][0] = 11
bb[5][0] = 12
bb[7][0] = 13
bb[0][1] = 14
bb[2][1] = 15
bb[4][1] = 16
bb[6][1] = 17
bb[1][2] = 19
bb[3][2] = 20
bb[5][2] = 21
bb[7][2] = 22
bb[0][3] = 23
bb[2][3] = 24
bb[4][3] = 25
bb[6][3] = 26
bb[1][4] = 28
bb[3][4] = 29
bb[5][4] = 30
bb[7][4] = 31
bb[0][5] = 32
bb[2][5] = 33
bb[4][5] = 34
bb[6][5] = 35
bb[1][6] = 37
bb[3][6] = 38
bb[5][6] = 39
bb[7][6] = 40
bb[0][7] = 41
bb[2][7] = 42
bb[4][7] = 43
bb[6][7] = 44



function shuffle(tbl)
  for i = #tbl,2,-1 do
    local j = math.random(i)
    tbl[i],tbl[j] = tbl[j],tbl[i]
  end
  return tbl
end


local function evaluation(b) 
 local code = 0; 
 local value = {}; 
 value[0],value[1],value[2],value[3],value[4] = 0,0,0,0,0 
 value[5],value[6] = 1,256 
 value[7],value[8] = 0,0 
 value[9],value[10] = 16 ,4096 
 value[11],value[12],value[13],value[14],value[15],value[16] = 0,0,0,0,0,0 
 for i,k in ipairs(b) do 
  code = code + value[ b[i] ] 
 end 

nwm = code % 16 
nwk = bit.arshift(code, 4) % 16 
nbm = bit.arshift(code, 8) % 16 
nbk = bit.arshift(code, 12) % 16

if (nbm + nbk) == 0 then
return (-5000)
end

if (nwm + nwk) == 0 then
return (5000)
end

v1 = 100*nbm + 130*nbk 
v2 = 100*nwm + 130*nwk 
eval = v1 - v2 
eval = eval + 250*(v1 - v2)/(v1 + v2)

if b[44] == bit.bor(BLACK,MAN) then 
if b[42] == bit.bor(BLACK,MAN) then 
eval = eval + 9 
end 
end 

if b[10] == bit.bor(WHITE,MAN) then 
if b[12] == bit.bor(WHITE,MAN) then 
eval = eval - 9 
end 
end 

return eval 
end 


local function cc(color) 
 local res 
 res = 3 - color 
 return res 
end 


function gen_white_moves(a) 
local movelist = {} 
for k,l in ipairs(a) do 
  if bit.band(a[k],WHITE ) ~= 0 then 
  if bit.band(a[k],MAN ) ~= 0 then 

  if bit.band(a[k + 4],FREE ) ~= 0 then 
  local board_copy = copy1(a) --{ unpack(a) } 
  board_copy.from = k 
  board_copy.to = k + 4 
  board_copy[k] = FREE 
  if ( k >= 37 ) then 
  board_copy[k + 4] = bit.bor(WHITE,KING) 
  else 
  board_copy[k + 4] = bit.bor(WHITE,MAN) 
  end 
  table.insert(movelist,board_copy) 
  end 
  if bit.band(a[k + 5],FREE ) ~= 0 then 
  local board_copy = copy1(a) --{ unpack(a) } 
  board_copy.from = k 
  board_copy.to = k + 5 
  board_copy[k] = FREE 
  if ( k >= 37 ) then 
  board_copy[k + 5] = bit.bor(WHITE,KING) 
  else 
  board_copy[k + 5] = bit.bor(WHITE,MAN) 
  end 
  table.insert(movelist,board_copy) 
  end 
  else -- MAN 
  if bit.band( a[k + 4],FREE ) ~= 0 then 
  local board_copy = copy1(a) --{ unpack(a) } 
  board_copy.from = k 
  board_copy.to = k + 4 
  board_copy[k] = FREE 
  board_copy[k + 4] = bit.bor(WHITE,KING) 
  table.insert(movelist,board_copy) 
  end 
  if bit.band( a[k + 5],FREE ) ~= 0 then 
  local board_copy = copy1(a) --{ unpack(a) } 
  board_copy.from = k 
  board_copy.to = k + 5 
  board_copy[k] = FREE 
  board_copy[k + 5] = bit.bor(WHITE,KING) 
  table.insert(movelist,board_copy) 
  end 
  if bit.band( a[k - 4],FREE ) ~= 0 then 
  local board_copy = copy1(a) --{ unpack(a) } 
  board_copy.from = k 
  board_copy.to = k - 4 
  board_copy[k] = FREE 
  board_copy[k - 4] = bit.bor(WHITE,KING) 
  table.insert(movelist,board_copy) 
  end 
  if bit.band( a[k - 5],FREE ) ~= 0 then 
  local board_copy = copy1(a) --{ unpack(a) } 
  board_copy.from = k 
  board_copy.to = k - 5 
  board_copy[k] = FREE 
  board_copy[k - 5] = bit.bor(WHITE,KING) 
  table.insert(movelist,board_copy) 
  end 
  end 
  end 
  end 
  return movelist 
end 

function gen_black_moves(a) 
local movelist = {} 

for k,l in ipairs(a) do 
 if bit.band(a[k],BLACK ) ~= 0 then 
 if bit.band(a[k],MAN ) ~= 0 then 

 if bit.band(a[k - 4],FREE ) ~= 0 then 
   local board_copy = copy1(a) --{ unpack(a) } 
   board_copy.from = k 
   board_copy.to = k - 4 
   board_copy[k] = FREE 
   if ( k <= 17 ) then 
   board_copy[k - 4] = bit.bor(BLACK,KING) 
   else 
   board_copy[k - 4] = bit.bor(BLACK,MAN) 
   end 
   table.insert(movelist,board_copy) 
 end 
 if bit.band(a[k - 5],FREE ) ~= 0 then 
   local board_copy = copy1(a) --{ unpack(a) } 
   board_copy.from = k 
   board_copy.to = k - 5 
   board_copy[k] = FREE 
   if ( k <= 17 ) then 
     board_copy[k - 5] = bit.bor(BLACK,KING) 
   else 
     board_copy[k - 5] = bit.bor(BLACK,MAN) 
   end 
   table.insert(movelist,board_copy) 
 end 
 else -- MAN 
 if bit.band(a[k - 5],FREE ) ~= 0 then 
   local board_copy = copy1(a) --{ unpack(a) } 
   board_copy.from = k 
   board_copy.to = k - 5 
   board_copy[k] = FREE 
   board_copy[k - 5] = bit.bor(BLACK,KING) 
   table.insert(movelist,board_copy) 
 end 
 if bit.band(a[k - 4],FREE ) ~= 0 then 
   local board_copy = copy1(a) --{ unpack(a) } 
   board_copy.from = k 
   board_copy.to = k - 4 
   board_copy[k] = FREE 
   board_copy[k - 4] = bit.bor(BLACK,KING) 
   table.insert(movelist,board_copy) 
 end 
 if bit.band(a[k + 5],FREE ) ~= 0 then 
   local board_copy = copy1(a) --{ unpack(a) } 
   board_copy.from = k 
   board_copy.to = k + 5 
   board_copy[k] = FREE 
   board_copy[k + 5] = bit.bor(BLACK,KING) 
   table.insert(movelist,board_copy) 
 end 
 if bit.band(a[k + 4],FREE ) ~= 0 then 
   local board_copy = copy1(a) --{ unpack(a) } 
   board_copy.from = k 
   board_copy.to = k + 4 
   board_copy[k] = FREE 
   board_copy[k + 4] = bit.bor(BLACK,KING) 
   table.insert(movelist,board_copy) 
 end 
 end 
 end 
end 
return movelist 
end 

local function gen_white_square(board,captures,square,depth) 
local mustSaveMove = true

if bit.band(board[square + 4],BLACK ) ~= 0 then 
if bit.band(board[square + 8],FREE ) ~= 0 then 
  mustSaveMove = false 
  
  if depth == 0 then 
  board.from = square 
  end 
  
  local board_copy = copy1(board) -- { unpack(board) } 
  board_copy[square] = FREE 
  board_copy[square + 4] = FREE 
  if ( square >= 32 ) then 
  board_copy[square + 8] = bit.bor(WHITE,KING) 
  board_copy.to = square + 8 -- 
  table.insert(captures,board_copy) 
  else 
  board_copy[square + 8] = bit.bor(WHITE,MAN) 
  board_copy.to = square + 8 -- 
  gen_white_square(copy3(board_copy),captures,(square + 8),(depth + 1)) 
  end 
end 
end 

if bit.band( board[square + 5],BLACK ) ~= 0 then 
if bit.band( board[square + 10],FREE ) ~= 0 then 
  mustSaveMove = false 

  if depth == 0 then
  board.from = square
  end
  
  local board_copy = copy1(board) -- { unpack(board) }
  board_copy[square] = FREE
  board_copy[square + 5] = FREE 
  if ( square >= 32 ) then 
  board_copy[square + 10] = bit.bor(WHITE,KING) 
  board_copy.to = square + 10 -- 
  table.insert(captures,board_copy) 
  else 
  board_copy[square + 10] = bit.bor(WHITE,MAN) 
  board_copy.to = square + 10 -- 
  gen_white_square(copy3(board_copy),captures,(square + 10),(depth + 1)) 
  end 
end 
end 

if ( mustSaveMove and depth > 0 ) then 
  table.insert(captures,board) 
end 

end 

local function gen_black_square(board,captures,square,depth) 
local mustSaveMove = true 

if bit.band( board[square - 4],WHITE ) ~= 0 then 
if bit.band( board[square - 8],FREE ) ~= 0 then 
  mustSaveMove = false 

  if depth == 0 then 
  board.from = square 
  end 
  
  local board_copy = copy1(board) -- { unpack(board) } 
  board_copy[square] = FREE 
  board_copy[square - 4] = FREE 
  if ( square <= 22 ) then 
  board_copy[square - 8] = bit.bor(BLACK,KING) 
  board_copy.to = square - 8 -- 
  table.insert(captures,board_copy) 
  else 
  board_copy[square - 8] = bit.bor(BLACK,MAN) 
  board_copy.to = square - 8 -- 
  gen_black_square(copy1(board_copy),captures,(square - 8),(depth + 1)) 
  end 
end 
end 

if bit.band(board[square - 5],WHITE ) ~= 0 then 
if bit.band(board[square - 10],FREE ) ~= 0 then 
  mustSaveMove = false 

  if depth == 0 then 
  board.from = square 
  end 
  
  local board_copy = copy1(board) -- { unpack(board) } 
  board_copy[square] = FREE 
  board_copy[square - 5] = FREE 
  if ( square <= 22 ) then 
  board_copy[square - 10] = bit.bor(BLACK,KING) 
  board_copy.to = square - 10 -- 
  table.insert(captures,board_copy) 
  else 
  board_copy[square - 10] = bit.bor(BLACK,MAN) 
  board_copy.to = square - 10 -- 
  gen_black_square(copy1(board_copy),captures,(square - 10),(depth + 1)) 
  end 
end 
end 

if ( mustSaveMove and depth > 0 ) then 
  table.insert(captures,board) 
end 

end 

local function gen_black_king_square(a,capturelist,k,depth) 
-- 
local mustSaveMove = true 
-- 
if bit.band(a[k + 5],WHITE) ~= 0 then 
if bit.band(a[k + 10],FREE) ~= 0 then 
  mustSaveMove = false 
  local board_copy = copy1(a) --{ unpack(a) } 
  if depth == 0 then
   board_copy.from = k
  end
  board_copy[k] = FREE 
  board_copy[k + 5] = FREE 
  board_copy[k + 10] = bit.bor(BLACK,KING) 
  board_copy.to = k + 10 --
  gen_black_king_square(board_copy,capturelist,(k + 10),(depth + 1)) 
end 
end 

if bit.band(a[k + 4],WHITE) ~= 0 then 
if bit.band(a[k + 8],FREE) ~= 0 then 
  mustSaveMove = false 
  local board_copy = copy1(a) --{ unpack(a) } 
  if depth == 0 then
   board_copy.from = k
  end
  board_copy[k] = FREE 
  board_copy[k + 4] = FREE
  board_copy[k + 8] = bit.bor(BLACK,KING) 
  board_copy.to = k + 8 --
  gen_black_king_square(board_copy,capturelist,(k + 8),(depth + 1)) 
end 
end 

if bit.band(a[k - 5],WHITE) ~= 0 then 
if bit.band(a[k - 10],FREE) ~= 0 then 
  mustSaveMove = false 
  local board_copy = copy1(a) --{ unpack(a) } 
  if depth == 0 then
  board_copy.from = k
  end
  board_copy[k] = FREE 
  board_copy[k - 5] = FREE
  board_copy[k - 10] = bit.bor(BLACK,KING) 
  board_copy.to = k - 10 --
  gen_black_king_square(board_copy,capturelist,(k - 10),(depth + 1)) 
end 
end 

if bit.band(a[k - 4],WHITE) ~= 0 then 
if bit.band(a[k - 8],FREE) ~= 0 then 
  mustSaveMove = false 
  local board_copy = copy1(a) --{ unpack(a) } 
  if depth == 0 then
   board_copy.from = k
  end
  board_copy[k] = FREE 
  board_copy[k - 4] = FREE
  board_copy[k - 8] = bit.bor(BLACK,KING) 
  board_copy.to = k - 8 --
  gen_black_king_square(board_copy,capturelist,(k - 8),(depth + 1)) 
end 
end 

if ( mustSaveMove and depth > 0 ) then 
table.insert(capturelist,a) 
end 

end 

local function gen_white_king_square(a,capturelist,k,depth) 
-- 
local mustSaveMove = true 
-- 
if bit.band(a[k + 5],BLACK) ~= 0 then 
if bit.band(a[k + 10],FREE) ~= 0 then 
  mustSaveMove = false 
  local board_copy = copy1(a) --{ unpack(a) } 
  if depth == 0 then
   board_copy.from = k
  end
  board_copy[k] = FREE 
  board_copy[k + 5] = FREE 
  board_copy[k + 10] = bit.bor(WHITE,KING) 
  board_copy.to = k + 10 --
  gen_white_king_square(board_copy,capturelist,(k + 10),(depth + 1)) 
end 
end

if bit.band(a[k + 4],BLACK) ~= 0 then 
if bit.band(a[k + 8],FREE) ~= 0 then 
  mustSaveMove = false 
  local board_copy = copy1(a) --{ unpack(a) } 
  if depth == 0 then 
   board_copy.from = k
  end
  board_copy[k] = FREE 
  board_copy[k + 4] = FREE 
  board_copy[k + 8] = bit.bor(WHITE,KING) 
  board_copy.to = k + 8 --
  gen_white_king_square(board_copy,capturelist,(k + 8),(depth + 1)) 
end 
end 

if bit.band(a[k - 5],BLACK) ~= 0 then 
if bit.band(a[k - 10],FREE) ~= 0 then 
  mustSaveMove = false 
  local board_copy = copy1(a) --{ unpack(a) } 
  if depth == 0 then
   board_copy.from = k
  end
  board_copy[k] = FREE 
  board_copy[k -  5] = FREE 
  board_copy[k - 10] = bit.bor(WHITE,KING) 
  board_copy.to = k - 10 --
  gen_white_king_square(board_copy,capturelist,(k - 10),(depth + 1)) 
end 
end 

if bit.band(a[k - 4],BLACK) ~= 0 then 
if bit.band(a[k - 8],FREE) ~= 0 then 
  mustSaveMove = false 
  local board_copy = copy1(a) --{ unpack(a) } 
  if depth == 0 then
   board_copy.from = k
  end
  board_copy[k] = FREE 
  board_copy[k - 4] = FREE 
  board_copy[k - 8] = bit.bor(WHITE,KING) 
  board_copy.to = k - 8 --
  gen_white_king_square(board_copy,capturelist,(k - 8),(depth + 1)) 
end 
end 

if ( mustSaveMove and depth > 0 ) then 
table.insert(capturelist,a) 
end 

end 

function gen_black_captures(a) 
local capturelist = {} 
a = copy1(a)
for k,l in ipairs(a) do 
  if bit.band( a[k],BLACK ) ~= 0 then 
  if bit.band( a[k],MAN ) ~= 0 then 
    gen_black_square(a,capturelist,k,0) 
  else 
    gen_black_king_square(a,capturelist,k,0) 
  end 
  end 
end 
return capturelist 
end 


function gen_white_captures(a) 
local capturelist = {} 
a = copy1(a)
for k,l in ipairs(a) do 
  if bit.band( a[k],WHITE ) ~= 0 then 
  if bit.band( a[k],MAN ) ~= 0 then 
    gen_white_square(a,capturelist,k,0) 
  else 
    gen_white_king_square(a,capturelist,k,0) 
  end 
  end 
end 
return capturelist 
end 

-- tested perft up to 12 depth and is OK
local function perft(board,depth,color) 
if ( depth == 0 ) then 
  return 1 
end 
local list = {} 
local nodes = 0 
if ( color == 1 ) then 
  list = gen_white_captures(board) 
  if (next(list) == nil) then 
    list = gen_white_moves(board) 
  end 
else 
  list = gen_black_captures(board) 
  if (next(list) == nil) then 
    list = gen_black_moves(board) 
  end 
end 
for k,l in ipairs(list) do 
  nodes = nodes + perft(list[k],(depth - 1),cc(color)) 
end 
return nodes 
end 

love.graphics.setBackgroundColor(0,1,0,1) 
--sriftas=love.graphics.newFont('CaviarDreams.ttf',60) 
--lg.setFont(sriftas) 

function translate(a)
-- for drawing rectangle coordinates
local stac = { {0,0},{0,0},{0,0},
{0,0},{0,0},{0,0},{0,0},
{0,0},{0,0},
{66,0},{198,0},{330,0},{462,0},
{0,66},{132,66},{264,66},{396,66},
{0,0},
{66,132},{198,132},{330,132},{462,132},
{0,198},{132,198},{264,198},{396,198},
{0,0},
{66,264},{198,264},{330,264},{462,264},
{0,330},{132,330},{264,330},{396,330},
{0,0},
{66,396},{198,396},{330,396},{462,396},
{0,462},{132,462},{264,462},{396,462},
{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},{0,0},
{0,0},{0,0},{0,0},{0,0} }

stac[0] = {0,0}

local c,d = stac[a][1],stac[a][2]
return c,d
end




local function alphabeta(board,depth,alpha,beta,color) 
-- 
if depth == 0 then 
  return evaluation(board) 
end 

local list = {} 

if (color == BLACK) then 

list = gen_black_captures(board) 
if ( next(list) == nil ) then 
list = gen_black_moves(board) 
if ( next(list) == nil ) then
return (-5000)
end

end 

end 

if (color == WHITE) then 

list = gen_white_captures(board) 
if ( next(list) == nil ) then 
list = gen_white_moves(board) 
if ( next(list) == nil ) then
return (5000)
end

end 

end 

for i,k in ipairs(list) do 
  value = alphabeta(list[i],depth - 1, alpha, beta,cc(color)) 
  if ( color == BLACK ) then 
     if value >= beta then 
        return value 
     end 
     alpha = math.max(alpha,value) 
  end 
  if ( color == WHITE ) then 
     if value <= alpha then 
        return value 
     end 
     beta = math.min(beta,value) 
  end 
end 

if color == BLACK then 
  return alpha 
else 
  return beta 
end 
end 


local function firstalphabeta(board,depth,alpha,beta,color) 
-- 
if depth == 0 then 
  return evaluation(board) 
end 

local list = {} 
local best = {}

if (color == BLACK) then 

list = gen_black_captures(board) 
if ( next(list) == nil ) then 
list = gen_black_moves(board) 
end 

end 

if (color == WHITE) then 

list = gen_white_captures(board) 
if ( next(list) == nil ) then 
list = gen_white_moves(board) 
end 

end

if ( next(list) == nil ) then
  return board,nil
end

list = shuffle(list)

for i,k in ipairs(list) do 
  value = alphabeta(list[i],depth - 1, alpha, beta,cc(color)) 
  if ( color == BLACK ) then 
     if value >= beta then 
        return value 
     end 
     if value > alpha then 
     alpha = value 
     best = copy1(list[i])
     end 
  end 
  if ( color == WHITE ) then 
     if value <= alpha then 
        return value 
     end 
     if value < beta then 
     beta = value 
     best = copy1(list[i])
     end 
   end 
end 

if color == BLACK then 
  return best,alpha 
else 
  return best,beta 
end 
end 


function wait(time)
--

local duration = os.time() + time
while os.time() < duration do end

end


function love.keypressed(k)
   if k == 'escape' then
     love.event.quit( "restart" )
   end
   if k == 'q' then
     love.event.quit()
   end
end


function love.mousepressed(x, y, button, istouch)
--  callback,no need to call this function by programmer
found = false
if tomove == WHITE then
  return
end

if x > 528 or y > 528 or x <= 0 or y <= 0 then
  return
end

local movelist = {}

if button == 1 then

if selected ~= nil then
MouseX,MouseY = x,y -- pressed coordinates
MouseX = math.floor(MouseX/66)
MouseY = math.floor(MouseY/66)
square_to = bb[MouseX][MouseY] -- clicked square on board

if square_to ~= 0 then
if bit.band(board[square_to],FREE) ~= 0 then

movelist = gen_black_captures(board) 
if ( next(movelist) == nil ) then 
  movelist = gen_black_moves(board) 
end
  
  for i,k in ipairs(movelist) do 
  if movelist[i].from == square_from then
  if movelist[i].to == square_to then
    board = movelist[i]
    found = true
  end
  end
  end
  
  
  
end -- FREE
end -- ~= 0

selected = nil

if found == true then
  tomove = WHITE
end
           
else

MouseX,MouseY = x,y -- pressed coordinates on screen
MouseX = math.floor(MouseX/66)
MouseY = math.floor(MouseY/66)
square_from = bb[MouseX][MouseY] -- clicked square on board

if square_from ~= 0 then
piece = board[square_from]

if bit.band(piece,BLACK) ~= 0 then
  selected = piece
else
  selected = nil
end
end
            

end -- else


end -- button

end -- function





--local nodes = perft(board,8,BLACK)



function love.update(dt)

if tomove == WHITE and found == true then
found = false
return
end


if tomove == WHITE then

now = os.time()
-- we can adjust depth on line 17
geras,verte = firstalphabeta(board,depth,-math.huge,math.huge,WHITE) 
board = geras
crnt = os.time()
elapsed = crnt - now -- not used this
love.audio.play( garsas )
tomove = BLACK

end

end



function love.draw()
-- piešinys atsiranda kada gryžta iš funkcijos-in lithuanian
-- drawing appears on screen when this function is complete,ie 
-- after return how much I understood

--[[
-- draw grid
love.graphics.setColor(0,1,0)
love.graphics.setLineWidth(1)

for i, line in ipairs(gridLines) do   
 love.graphics.line(line) 
end
--
--]]

love.graphics.draw(img,0,0,0,528/img:getWidth(),528/img:getHeight())

-- draw board
for i,k in ipairs(board) do
  if board[i] ~= 0 and board[i] ~= FREE then

  if bit.band(board[i],WHITE) ~= 0 then
  love.graphics.setColor(1,1,1)
  else
  love.graphics.setColor(1,0,0)
  end

  if bit.band(board[i],KING) ~= 0 then
  love.graphics.circle("fill",aa[i][1],aa[i][2],10)
  love.graphics.circle("line",aa[i][1],aa[i][2],20)
  else
  love.graphics.circle("fill",aa[i][1],aa[i][2],20)
  end
  
  end
end
--
love.graphics.reset()
-- draw rectangle-- not used so far,highlight pressed square
if xd ~= nil and yd ~= nil then
love.graphics.setColor(0,0,1)
lg.rectangle("line",xd,yd,66,66) -- fill
end
--

end


